package com.uas.erp.schedular.finance.task;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;
import com.uas.erp.schedular.entity.Master;
import com.uas.erp.schedular.task.support.Method;
import com.uas.erp.schedular.util.ContextHolder;
import com.usoft.fin.external.open.api.entity.*;
import com.usoft.fin.external.open.api.protobuf.*;
import com.usoft.sdk.fin.client.CapitalSideSdk;
import com.usoft.sdk.fin.client.TradingHallSdk;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import com.uas.erp.schedular.task.support.Role;
import com.uas.erp.schedular.task.support.TaskMapping;
import com.usoft.fin.external.open.api.protobuf.GetOfferQuotaInfoListReq;
import com.usoft.fin.external.open.api.protobuf.GetOfferQuotaInfoListResp;
import com.usoft.sdk.fin.utils.ProtoBufUtil;

@Component
@TaskMapping(title = "U智融对接服务", role = Role.SELLER)
public class B2BInformation  extends AbstractTask{
	@Autowired
	private CustInfomationTask custInfomationTask;
	//private CapitalSideSdk capitalSideSdk = new CapitalSideSdk("https://finrest.uuzcc.cn", "10046945", "b78d577449b64f56a8a6cf1feeb3fbf5");
	private CapitalSideSdk capitalSideSdk = new CapitalSideSdk("https://finrest.yitoa-fintech.com", "10046945", "600d3f07955ba67fe050007f01002db2");
	/**
     * 额度申请
     * @throws Exception
     */
	@TaskMapping(title = "额度申请下载", fixedDelay = 30000, method = Method.DOWNLOAD)
    public void getOfferQuotaInfoList() throws Exception {
		List<String> sqls = new ArrayList<>();
		/*long curt = System.currentTimeMillis();
		int cCount = jdbcTemplate.count("FROM CONFIGS WHERE CALLER = 'sys' AND CODE ='lastLoadQuotaTime'");
		if(cCount == 0){
			jdbcTemplate.execute("Insert into CONFIGS (CODE,TITLE,DATA_TYPE,DATA,CALLER,MULTI,ID,EDITABLE) values " +
					"('lastLoadQuotaTime','上次同步额度申请时间','VARCHAR2','"+curt+"','sys',0,CONFIGS_SEQ.NEXTVAL,1)");
		}
		Object lastTime = jdbcTemplate.getObject("SELECT MAX(DATA) FROM CONFIGS WHERE CALLER = 'sys' AND CODE ='lastLoadQuotaTime'");*/
		Master currMaster = ContextHolder.getMaster();
    	GetOfferQuotaInfoListReq.Builder req = GetOfferQuotaInfoListReq.newBuilder();
    	req.setCsEnuu(10046945); //req.setCsEnuu(Integer.valueOf(currMaster.getMa_uu().toString()));
    	req.setPageNumber(1);
    	req.setPageSize(100);
		/*if(lastTime != null){//未配置则取全部数据
			long lt = Long.valueOf(String.valueOf(lastTime));
			req.setUpdateTime(lt);//获取上次更新时间结束后被更新的单据列表
		}*/
		GetOfferQuotaInfoListResp resp = capitalSideSdk.getOfferQuotaInfoList(req);
		List<OfferQuotaAndOfferQuotaInfoRest> restlist = resp.getOfferQuotaAndOfferQuotaInfoList();
		List<Map<String, Object>> enUUList = new ArrayList<>();
		for(OfferQuotaAndOfferQuotaInfoRest rest : restlist) {
			Map<String, Object> enMap = new HashMap<>();
			if (rest.getOfferQuoteInfo().getFsEnuu() > 0) {
				sqls.add("MERGE INTO CUSTOMERQUOTA INERP " +
						"	USING ( SELECT nvl(MAX(CQ_ID),-1) CQ_ID," +
						"	MAX((select MAX(CU_CODE) from CUSTOMERINFOR WHERE CU_STATUSCODE <> 'DISABLE' AND NVL(CU_ENUU,0) = "+rest.getOfferQuoteInfo().getFsEnuu()+" )) CU_CODE " +
						"	FROM CustomerQuota WHERE CQ_CODE = '" + rest.getOfferQuoteInfo().getCode() + "' ) ONERP " +
						"	ON (INERP.CQ_ID = ONERP.CQ_ID) " +
						"	WHEN MATCHED THEN " +
						"	UPDATE SET INERP.CQ_UPDATEDATE = SYSDATE,INERP.CQ_UPLOADSTATUS='已上传',INERP.CQ_QUOTATYPE='卖方客户',INERP.CQ_COP='"+currMaster.getMa_user()+"',INERP.CQ_CLASS='卖方客户申请单'," +
						"	INERP.CQ_CUSTCODE = ONERP.CU_CODE," +
						"	INERP.CQ_CUSTUU = " + rest.getOfferQuoteInfo().getFsEnuu() + ",INERP.CQ_CUSTNAME='" + rest.getOfferQuoteInfo().getFsEnName() + "'," +
						"	INERP.CQ_APPLYQUOTA=" + rest.getOfferQuoteInfo().getQuotaAmount()*10000 + ",INERP.CQ_EFFECTDAYS=" + rest.getOfferQuoteInfo().getCredDays() + ",INERP.CQ_LENDRATE=" + rest.getOfferQuoteInfo().getFinanceRate() + "," +
						"	INERP.CQ_ANNUALRATE=" + rest.getOfferQuoteInfo().getOfferRate() + ",INERP.CQ_REPAYMENTMEANS='" + rest.getOfferQuoteInfo().getRepayment() + "'," +
						"	INERP.CQ_AUDITDATE = TO_DATE('" + rest.getOfferQuoteInfo().getCheckerTime() + "','YYYY-MM-DD hh24:mi:ss')," +
						"	INERP.CQ_STATUSCODE='" + (rest.getOfferQuoteInfo().getStatus() == 1402 ? "AUDITED" : "ENTERING") + "'," +
						"	INERP.CQ_STATUS='" + (rest.getOfferQuoteInfo().getStatus() == 1402 ? "已审核" : "在录入") + "'," +
						"	INERP.CQ_QUOTA=" + rest.getOfferQuoteInfo().getQuotaAmount()+ ","+
						"	INERP.CQ_BASICEVALUATION='" + rest.getOfferQuoteInfo().getCheckerContent() + "'" +
						"	WHEN NOT MATCHED THEN " +
						"	INSERT (CQ_ID,CQ_UPLOADSTATUS,CQ_SOURCETYPE,CQ_QUOTATYPE,CQ_UPDATEDATE,CQ_COP,CQ_CLASS," +
						"	CQ_CODE,CQ_FACTORUU,CQ_FACTORNAME,CQ_CUSTCODE,CQ_CUSTUU,CQ_CUSTNAME," +
						"	CQ_APPLYQUOTA,CQ_EFFECTDAYS,CQ_LENDRATE,CQ_ANNUALRATE,CQ_REPAYMENTMEANS," +
						"	CQ_INDATE,CQ_RECORDER,CQ_RECORDERUU,CQ_AUDITDATE," +
						"	CQ_STATUSCODE,CQ_STATUS,CQ_BASICEVALUATION,CQ_ISEFFECT,CQ_QUOTA)" +
						"	VALUES(CUSTOMERQUOTA_SEQ.NEXTVAL,'待上传','B2B','卖方客户',SYSDATE,'"+ currMaster.getMa_user()+"','卖方客户申请单'," +
						"	'" + rest.getOfferQuoteInfo().getCode() + "'," + rest.getOfferQuoteInfo().getCsEnuu() + ",'" + rest.getOfferQuoteInfo().getCsEnName() + "',ONERP.CU_CODE," + rest.getOfferQuoteInfo().getFsEnuu() + ",'" + rest.getOfferQuoteInfo().getFsEnName() + "'," +
						"	" + rest.getOfferQuoteInfo().getQuotaAmount()*10000 + "," + rest.getOfferQuoteInfo().getCredDays() + "," + rest.getOfferQuoteInfo().getFinanceRate() + "," + rest.getOfferQuoteInfo().getOfferRate() + ",'" + rest.getOfferQuoteInfo().getRepayment() + "'," +
						"	TO_DATE('" + rest.getOfferQuoteInfo().getApplyTime() + "','YYYY-MM-DD hh24:mi:ss'),'" + rest.getOfferQuoteInfo().getApplyUsername() + "'," + rest.getOfferQuoteInfo().getApplyUu() + ",TO_DATE('" + rest.getOfferQuoteInfo().getCheckerTime() + "','YYYY-MM-DD hh24:mi:ss')," +
						"	'" + (rest.getOfferQuoteInfo().getStatus() == 1402 ? "AUDITED" : "ENTERING") + "','" + (rest.getOfferQuoteInfo().getStatus() == 1402 ? "已审核" : "在录入") + "','" + rest.getOfferQuoteInfo().getCheckerContent() + "','未生效','" + rest.getOfferQuoteInfo().getQuotaAmount() + "')");
				enMap.put("CQ_CODE",rest.getOfferQuoteInfo().getCode());
				enMap.put("CQ_CUSTUU", rest.getOfferQuoteInfo().getFsEnuu());
				enMap.put("CQ_FACTORUU", rest.getOfferQuoteInfo().getCsEnuu());
				enMap.put("CQ_RECORDERUU", rest.getOfferQuoteInfo().getApplyUu());
				if (!enUUList.contains(enMap)) {
					enUUList.add(enMap);
				}
			}
		}
		jdbcTemplate.batchExecute(sqls);
		/*List<Map<String, Object>> list = jdbcTemplate.queryForList("select cq_custname,cq_auditdate, cq_status from CUSTOMERQUOTA where 1=?", 1);
		for(int i = 0;i<list.size();i++){
			Object auditdate = jdbcTemplate.getObject("select to_char(max(cq_auditdate),'yyyy-MM-dd') from CUSTOMERQUOTA "
					+ " where cq_custname = ?",list.get(i).get("CQ_CUSTNAME"));
			if(auditdate != null){
				jdbcTemplate.execute("update CUSTOMERQUOTA set CQ_ISEFFECT = '已生效' where cq_custname = ? and "
						+ " cq_auditdate = ? and cq_status = ?", list.get(i).get("CQ_CUSTNAME"),auditdate,"已审核");
			}
			
		}*/
        //System.out.println(sqls);
		/*if(cCount > 0){
			//记录本次抓取时间
			sqls.add("UPDATE CONFIGS SET DATA = '"+curt+"' WHERE CALLER = 'sys' AND CODE ='lastLoadQuotaTime'");
		}*/
		
		
		
		//下载或更新客户信息
		if(enUUList.size()>0){
			custInfomationTask.getCustInfomation(enUUList);
		}
    }
	
	/**
	 * 上传卖方客户额度申请
	 * @throws Exception
	 */
	@TaskMapping(title = "上传卖方客户额度申请", fixedDelay = 30000, method = Method.UPLOAD)
	public void saveOfferQuotaInfoReq() throws Exception{
		List<Map<String, Object>> customerQuotaUpload = getCustomerQuotaUpload();
		if (!CollectionUtils.isEmpty(customerQuotaUpload)) {
            List<String> sqlList = new ArrayList<>();
			for (Map<String, Object> map:customerQuotaUpload) {
                //资金方UU
                Object cq_factoruu = map.get("CQ_FACTORUU");
                Integer cqFactoruu =10046945;
                //Integer cqFactoruu =10046945; //线上
                if (cq_factoruu!=null) {
                   cqFactoruu = Integer.valueOf(cq_factoruu.toString());
                }

			    //融资方UU
                Object cq_custuu = map.get("CQ_CUSTUU");
                Integer cqCustuu =0;
                if (cq_custuu!=null) {
                    cqCustuu = Integer.valueOf(cq_custuu.toString());
                }
                //融资方企业名称
                String cqCustname = map.get("CQ_CUSTNAME").toString();
                //授信期限(月)
                Integer cqEffectdays = Integer.valueOf(map.get("CQ_EFFECTDAYS").toString());
			    //当前额度
            	Double  cqQuota = Double.valueOf(map.get("CQ_QUOTA").toString())/10000;
                
                //融资比例
                Double cqLendrate = Double.valueOf(map.get("CQ_LENDRATE").toString());
                //年化利率
                Double cqAnnualrate = Double.valueOf(map.get("CQ_ANNUALRATE").toString());
                //还款方式
                String cqRepaymentmeans = map.get("CQ_REPAYMENTMEANS").toString();
                //录入人UU
                Object cq_recorderuu = map.get("CQ_RECORDERUU");
                Integer cqRecorderuu =200040254;
                //Integer cqRecorderuu =1000014617;  // 线上
				if (cq_recorderuu!=null) {
					cqRecorderuu = Integer.valueOf(cq_recorderuu.toString());
				}
				//审核结果
				Object cq_approval = map.get("CQ_APPROVAL");
				Integer cqApproval=1403;
				if (Integer.valueOf(cq_approval.toString())==1){
					cqApproval=1402;
				}
				//到期时间
				SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				Object cq_enddate = map.get("CQ_ENDDATE");
				String cqEnddate = format.format(new Date());
				if (cq_enddate!=null){
					cqEnddate = format.format(new Date(Long.valueOf(cq_enddate.toString())));
				}
				//基本面评价
				Object cq_basicevaluation = map.get("CQ_BASICEVALUATION");
				String cqBasicevaluation = "";
				if (cq_basicevaluation!=null){
					cqBasicevaluation = cq_basicevaluation.toString();
				}

				SaveOfferQuotaInfoReq.Builder req = SaveOfferQuotaInfoReq.newBuilder();
				req.setCsEnuu(cqFactoruu).setCsEnName("深圳市英唐保理有限公司").setFsEnuu(cqCustuu).setFsEnName(cqCustname).setQuotaAmount(cqQuota)
						.setCredDays(cqEffectdays).setFinanceRate(cqLendrate).setOfferRate(cqAnnualrate).setRepayment(
                        cqRepaymentmeans).setApplyUu(cqRecorderuu).setPreviousRecord("");
				SaveOfferQuotaInfoResp resp = capitalSideSdk.saveOfferQuotaInfo(req);
                String s = ProtoBufUtil.toJSON(resp);
                JSONObject jsonObject = JSONObject.parseObject(s);
                Object code = JSONObject.parseObject(jsonObject.get("respHeader").toString()).get("code");
				Object msg = JSONObject.parseObject(jsonObject.get("respHeader").toString()).get("msg");
                if ("0".equals(code.toString())||(msg!=null&&"您已经为该企业申请过报价额度，请不要重复申请".equals(msg.toString()))){
					UpdateOfferQuotaInfoReq.Builder builder = UpdateOfferQuotaInfoReq.newBuilder();
					builder.setCsEnuu(cqFactoruu).setFsEnuu(cqCustuu).setStatus(cqApproval).setEndTime(cqEnddate)
							.setCheckerContent(cqBasicevaluation).setCheckUu(cqRecorderuu);
					UpdateOfferQuotaInfoResp infoResp = capitalSideSdk.updateOfferQuotaInfo(builder);
					String ss = ProtoBufUtil.toJSON(infoResp);
					JSONObject json = JSONObject.parseObject(ss);
					Object code1 = JSONObject.parseObject(json.get("respHeader").toString()).get("code");
					if ("0".equals(code1.toString())) {
						sqlList.add("update customerQuota set CQ_UPLOADSTATUS = '已上传' where cq_id = " + map.get("CQ_ID"));
					}
                }
			}
            if (!CollectionUtils.isEmpty(sqlList)) {
                jdbcTemplate.batchExecute(sqlList);
            }
		}
	}

	/**
	 * 获取需要上传的卖方客户额度申请
	 *
	 * @return
	 */
	private List<Map<String, Object>> getCustomerQuotaUpload() {
		List<Map<String, Object>> maps = jdbcTemplate.queryForList("select * from (select cq_id,cq_factoruu," +
                "cq_custuu,cq_custname,cq_effectdays,cq_quota,cq_lendrate,cq_annualrate," +
                "cq_repaymentmeans,cq_recorderuu,cq_approval,cq_enddate,cq_basicevaluation from " +
                "customerQuota where " +
				"CQ_UPLOADSTATUS='待上传' and cq_status = '已审核' and cq_quotatype='卖方客户' order by cq_code ) where rownum " +
                "< 100");
		return maps;
	}
	
}

